<?php





/**





 * @package Admin





 */











if ( !defined( 'WPSEO_VERSION' ) ) {





	header( 'HTTP/1.0 403 Forbidden' );





	die;





}











/**





 * Class that handles the edit boxes on taxonomy edit pages.





 */





class WPSEO_Taxonomy {











	/**





	 * Class constructor





	 */





	function __construct() {





		$options = get_seamlessseo_options();











		if ( is_admin() && isset( $_GET['taxonomy'] ) &&





			( !isset( $options['tax-hideeditbox-' . $_GET['taxonomy']] ) || !$options['tax-hideeditbox-' . $_GET['taxonomy']] )





		)





			//add_action( $_GET['taxonomy'] . '_edit_form', array( $this, 'term_seo_form' ), 10, 1 );





 





		add_action( 'edit_term', array( $this, 'update_term' ), 99, 3 );











		add_action( 'init', array( $this, 'custom_category_descriptions_allow_html' ) );





		add_filter( 'category_description', array( $this, 'custom_category_descriptions_add_shortcode_support' ) );





	}

















	/**





	 * Update the taxonomy meta data on save.





	 *





	 * @param int    $term_id  ID of the term to save data for





	 * @param int    $tt_id    The taxonomy_term_id for the term.





	 * @param string $taxonomy The taxonmy the term belongs to.





	 */





	function update_term( $term_id, $tt_id, $taxonomy ) {





		$tax_meta = get_option( 'seamlessseo_taxonomy_meta' );











		if ( !isset($tax_meta[$taxonomy]) || !isset($tax_meta[$taxonomy][$term_id]) || !is_array( $tax_meta[$taxonomy][$term_id] ) )





			$tax_meta[$taxonomy][$term_id] = array();











		foreach ( array( 'title', 'desc', 'metakey', 'bctitle', 'canonical', 'noindex', 'sitemap_include' ) as $key ) {





			if ( isset( $_POST['seamlessseo_' . $key] ) && !empty( $_POST['seamlessseo_' . $key] ) ) {





				$val = trim( $_POST['seamlessseo_' . $key] );











				if ( $key == 'canonical' )





					$val = esc_url( $val );





				else





					$val = esc_html( $val );











				$tax_meta[$taxonomy][$term_id]['seamlessseo_' . $key] = $val;





			} else {





				if ( isset( $tax_meta[$taxonomy][$term_id]['seamlessseo_' . $key] ) )





					unset( $tax_meta[$taxonomy][$term_id]['seamlessseo_' . $key] );





			}





		}











		update_option( 'seamlessseo_taxonomy_meta', $tax_meta, 99 );











		if ( defined( 'W3TC_DIR' ) && class_exists( 'W3_ObjectCache' ) ) {





			require_once( W3TC_DIR . '/lib/W3/ObjectCache.php' );





			$w3_objectcache = & W3_ObjectCache::instance();











			$w3_objectcache->flush();





		}





	}











	/**





	 * Allows HTML in descriptions





	 */





	function custom_category_descriptions_allow_html() {





		$filters = array(





			'pre_term_description',





			'pre_link_description',





			'pre_link_notes',





			'pre_user_description'





		);











		foreach ( $filters as $filter ) {





			remove_filter( $filter, 'wp_filter_kses' );





		}





		remove_filter( 'term_description', 'wp_kses_data' );





	}











	/**





	 * Adds shortcode support to category descriptions.





	 *





	 * @param string $desc String to add shortcodes in.





	 * @return string





	 */





	function custom_category_descriptions_add_shortcode_support( $desc ) {





		// Wrap in output buffering to prevent shortcodes that echo stuff instead of return from breaking things.





		ob_start();





		$desc = do_shortcode( $desc );





		ob_end_clean();











		return $desc;





	}











}











$seamlessseo_taxonomy = new WPSEO_Taxonomy();





