<?php





/*





Plugin Name: Seamless SEO





Version: 1.0.0





Description: The Complete  SEO at one place for WordPress, including on-page content analysis, rel=follow,no follow,google authorship,post type to permalinks.





Author: Radu Hahaianu





 */





if ( !defined( 'DB_NAME' ) ) {





	header( 'HTTP/1.0 403 Forbidden' );





	die;





}











if ( !defined( 'WPSEO_PATH' ) )





	define( 'WPSEO_PATH', plugin_dir_path( __FILE__ ) );





if ( !defined( 'WPSEO_BASENAME' ) )





	define( 'WPSEO_BASENAME', plugin_basename( __FILE__ ) );











define( 'WPSEO_FILE', __FILE__ );











function seamlessseo_load_textdomain() {





	load_plugin_textdomain( 'wordpress-seo', false, dirname( plugin_basename( __FILE__ ) ) . '/languages/' );





}





add_filter( 'wp_loaded', 'seamlessseo_load_textdomain' );

















if ( version_compare( PHP_VERSION, '5.2', '<' ) ) {





	if ( is_admin() && ( !defined( 'DOING_AJAX' ) || !DOING_AJAX ) ) {





		require_once( ABSPATH . 'wp-admin/includes/plugin.php' );





		deactivate_plugins( __FILE__ );





		wp_die( sprintf( __( 'WordPress SEO requires PHP 5.2 or higher, as does WordPress 3.2 and higher. The plugin has now disabled itself. For more info, %s$1see this post%s$2.', 'wordpress-seo' ), '<a href="http://seo_complete.com/requires-php-52/">', '</a>' ) );





	} else {





		return;





	}





}





define( 'WPSEO_VERSION', '1.4.22' );











function seamlessseo_init() {





	require_once( WPSEO_PATH . 'inc/seamlessseo-functions.php' );











	$options = get_seamlessseo_options();











	if ( isset( $options['stripcategorybase'] ) && $options['stripcategorybase'] )





		require_once( WPSEO_PATH . 'inc/class-rewrite.php' );





}











/**





 * Used to load the required files on the plugins_loaded hook, instead of immediately.





 */





function seamlessseo_frontend_init() { 





	$options = get_seamlessseo_options();





	require_once( WPSEO_PATH . 'frontend/class-frontend.php' );





	if ( isset( $options['breadcrumbs-enable'] ) && $options['breadcrumbs-enable'] )





		require_once( WPSEO_PATH . 'frontend/class-breadcrumbs.php' );





}











/**





 * Used to load the required files on the plugins_loaded hook, instead of immediately.





 */





function seamlessseo_admin_init() {





	$options = get_seamlessseo_options();





	if ( isset( $_GET['seamlessseo_restart_tour'] ) ) {





		unset( $options['ignore_tour'] );





		update_option( 'seamlessseo', $options );





	}

















	require_once( WPSEO_PATH . 'admin/class-admin.php' );











	global $pagenow;





	if ( in_array( $pagenow, array( 'edit.php', 'post.php', 'post-new.php' ) ) ) {





		require_once( WPSEO_PATH . 'admin/class-metabox.php' );





	}











	if ( in_array( $pagenow, array( 'edit-tags.php' ) ) )





		require_once( WPSEO_PATH . 'admin/class-taxonomy.php' );











	if ( in_array( $pagenow, array( 'admin.php' ) ) )





		require_once( WPSEO_PATH . 'admin/class-config.php' );





}











add_action( 'plugins_loaded', 'seamlessseo_init', 14 );























if ( !defined( 'DOING_AJAX' ) || !DOING_AJAX )





	require_once( WPSEO_PATH . 'inc/seamlessseo-non-ajax-functions.php' );











if ( is_admin() ) {





	if ( defined( 'DOING_AJAX' ) && DOING_AJAX ) {





		require_once( WPSEO_PATH . 'admin/ajax.php' );





	} else {





		add_action( 'plugins_loaded', 'seamlessseo_admin_init', 15 );





	}











	register_activation_hook( __FILE__, 'seamlessseo_activate' );





	//register_deactivation_hook( __FILE__, 'seamlessseo_deactivate' );





	register_uninstall_hook(__FILE__,'galink_remove_option' );





} else {





	add_action( 'plugins_loaded', 'seamlessseo_frontend_init', 15 );





}





unset( $options );





